%global momorel 4
%global md5sum_src0 e52a7ea6ba9743a8f8ca397cd26fa1bf
%global _numjobs 1

Summary: packet-sniffer/logger
Name: snort
Version: 2.6.1.5
Release: %{momorel}m%{?dist}
License: GPL
Group: Applications/Internet
#Source0: http://www.snort.org/dl/old/snort-%{version}.tar.gz
%NoSource 0 http://www.snort.org/dl/current/snort-%{version}.tar.gz %{md5sum_src0}
Source1: snortd
Patch0: snort-2.4.4-lib64.patch
URL: http://www.snort.org/
Buildroot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: libpcap-devel >= 0.9.5
BuildRequires: mysql-devel
BuildRequires: pcre-devel
BuildRequires: postgresql-devel >= 8.2.3
PreReq: chkconfig, shadow-utils

%description
Snort is a libpcap-based packet sniffer/logger which can be used as a
lightweight network intrusion detection system.  It features rules based
logging and can perform protocol analysis, content searching/matching
and can be used to detect a variety of attacks and probes, such as
buffer overflows, stealth port scans, CGI attacks, SMB probes, OS
fingerprinting attempts, and much more.  Snort has a real-time alerting
capabilty, with alerts being sent to syslog, a seperate "alert" file, or
as a WinPopup message via Samba's smbclient
#'

%prep
%setup -q
%if %{_lib} == "lib64"
%patch0 -p1 -b .lib64~
%endif

%build
aclocal -I m4
autoheader
autoconf
libtoolize --force --copy
automake --foreign --add-missing
%configure --bindir=%{_sbindir} \
 --sysconfdir=/etc/snort \
 --enable-dynamicplugin \
 --with-postgresql \
 --with-mysql 
%make
perl -pi -e 's,^var RULE_PATH.*$,var RULE_PATH %{_sysconfdir}/snort/rules,' etc/snort.conf
perl -pi -e 's,dynamicpreprocessor directory /usr/local/lib/snort_dynamicpreprocessor/,dynamicpreprocessor directory %{_libdir}/snort/dynamicpreprocessor/,' etc/snort.conf
perl -pi -e 's,dynamicengine /usr/local/lib/snort_dynamicengine/libsf_engine.so,dynamicengine %{_libdir}/snort/dynamicengine/libsf_engine.so,' etc/snort.conf

%install
[ "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}
mkdir -p %{buildroot}/etc/snort
mkdir -p %{buildroot}/etc/snort/rules
mkdir -p %{buildroot}/var/log/snort/archive
mkdir -p %{buildroot}%{_initscriptdir}
mkdir -p %{buildroot}%{_mandir}/man8

%makeinstall bindir=%{buildroot}%{_sbindir}

install %{SOURCE1} %{buildroot}%{_initscriptdir}
install etc/* %{buildroot}/etc/snort
rm -f %{buildroot}/etc/snort/Makefile*
install %{name}.8 %{buildroot}%{_mandir}/man8
rm -rf doc/Makefile* contrib/Makefile* contrib/rpm
chmod -x contrib/*
find %{buildroot} -name "*.la" -delete
rm -rf  %{buildroot}/usr/src
{
 cd %{buildroot}%{_libdir}
 mkdir -p snort/dynamicengine
 mkdir -p snort/dynamicpreprocessor
 mv libsf_engine.*            snort/dynamicengine
 mv libsf_ftptelnet_preproc.* snort/dynamicpreprocessor
 mv libsf_smtp_preproc.*      snort/dynamicpreprocessor
 mv libsf_dns_preproc.*       snort/dynamicpreprocessor
 mv libsf_dcerpc_preproc.*    snort/dynamicpreprocessor
 mv libsf_ssh_preproc.*       snort/dynamicpreprocessor
}

%clean
[ "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}

%pre
if ! grep -q '^snort:' /etc/group; then
  /usr/sbin/groupadd -r snort
fi
if ! grep -q '^snort:' /etc/passwd; then
  /usr/sbin/useradd -M -r -d /var/log/snort -s /bin/false -g snort -c "Snort" snort || :
fi

%post
/sbin/chkconfig --add snortd
echo -e "
Be sure to fetch the latest snort rules file from the ArachNIDS
database by Max Vision, or the one available from the snort.org web
site.

The snortlog and snort-stat perl scripts can be used to generate
statistics from the snort syslog entries.

Snort is currently configured to listen only on eth0, and uses the
default rulesets. If this is not correct for your system, edit
/etc/init.d/snortd and /etc/snort/snort.conf
"

%preun
if [ -f /var/lock/subsys/snortd ] ; then
  %{_initscriptdir}/snortd stop
fi
if [ $1 = 0 ] ; then
  /sbin/chkconfig --del snortd
fi

%postun
if [ $1 = 0 ]; then
  if [ `grep snort /etc/passwd | wc -l` = 1 ]; then
    /usr/sbin/userdel snort
  fi
  if [ `grep snort /etc/group | wc -l` = 1 ]; then
    /usr/sbin/groupdel snort
  fi
fi

%files
%defattr(-,root,root)
%doc COPYING ChangeLog LICENSE doc/* contrib
%attr(750,root,root) %config(noreplace) %{_initscriptdir}/snortd
%attr(640,snort,snort) %config(noreplace) /etc/snort/snort.conf
%attr(750,snort,snort) %config /etc/snort/rules
%attr(640,snort,snort) %config /etc/snort/*.config
%attr(640,snort,snort) %config /etc/snort/threshold.conf
%attr(640,snort,snort) %config /etc/snort/*.map
%attr(640,snort,snort) %config /etc/snort/generators
%attr(640,snort,snort) %config /etc/snort/sid
%attr(750,snort,snort) /var/log/snort
%{_mandir}/man8/%{name}*
%{_sbindir}/*
%{_libdir}/snort


%changelog
* Thu Jun 07 2007 TABUCHI Takaaki <tab@momonga-linux.org>
- (2.6.1.5-4m)
- rebuild against libpcap-0.9.5 (restrict by version)

* Wed Jun  6 2007 NARITA Koichi <pulsar@momonga-linux.org>
- (2.6.1.5-3m)
- rebuild against libpcap-0.9.5

* Wed May 30 2007 Ryu SASAOKA <ryu@momonga-linux.org>
- (2.6.1.5-2m)
- numjobs 1
- revised spec

* Wed May 30 2007 Ryu SASAOKA <ryu@momonga-linux.org>
- (2.6.1.5-1m)
- [SECURITY] CVE-2006-6931 CVE-2006-5276
- update to 2.6.1.5

* Sun Mar 11 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (2.4.5-2m)
- rebuild against postgresql-8.2.3

* Tue Jun 13 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (2.4.5-1m)
- update to 2.4.5
-- CVE-2006-2769
-- http://www.cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2006-2769

* Tue May 17 2006 Yasuo Ohgaki <yohgaki@momonga-linux.org>
- (2.4.4-2m)
- rebuild against mysql 5.0.22-1m

* Mon Mar 13 2006 Ryu SASAOKA <ryu@momonga-linux.org>
- (2.4.4-1m)
- update to 2.4.4
- [SECURITY] CVE-2006-0839
- removed rules which are now external to the distro from 2.4.0 release.
- download from http://www.snort.org/pub-bin/downloads.cgi

* Sat Nov 19 2005 Shigeyuki Yamashita <shige@momonga-linux.org>
- (2.3.3-3m)
- rebuild against postgresql-8.1.0

* Mon Sep  5 2005 YONEKAWA Susumu <yonekawa@mmg.roka.jp>
- (2.3.3-2m)
- rebuild against for MySQL-4.1.14

* Mon May 2 2005 Kazuya Iwamoto <iwapi@momonga-linux.org>
- (2.3.3-1m)
- update to 2.3.3
 1. Fixed sfPortscan Open Ports not getting suppressed.
 2. Added new mini-preprocessor to catch the X-Link2State vulnerability.

* Mon Apr 25 2005 Toru Hoshina <t@momonga-linux.org>
- (2.3.2-2m)
- rebuild against postgresql-8.0.2.

* Thu Mar 19 2005 IWAMOTO Kazuya <iwapi@momonga-linux.org>
- (2.3.2-1m)
- update to 2.3.2

* Thu Feb 10 2005 Dai OKUYAMA <dai@ouchi.nahi.to>
- (2.3.0-2m)
- enable x86_64.

* Thu Jan 26 2005 IWAMOTO Kazuya <iwapi@momonga-linux.org>
- (2.3.0-1m)
- update to 2.3.0

* Thu Aug 19 2004 IWAMOTO Kazuya <iwapi@momonga-linux.org>
- (2.2.0-1m)
- update to 2.2.0

* Wed Jun  9 2004 IWAMOTO Kazuya <iwapi@momonga-linux.org>
- (2.1.3-1m)
- update to 2.1.3

* Wed Apr  7 2004 Kazuhiko <kazuhiko@fdiary.net>
- (2.1.2-1m)
- bugfix release

* Fri Dec 19 2003 Kazuhiko <kazuhiko@fdiary.net>
- (2.1.0-2m)
- add missing files

* Fri Dec 19 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (2.1.0-1m)
- update to 2.1.0
- add BuildRequires: pcre-devel for use prce.h
- add BuildRequires: postgresql-devel

* Tue Dec  9 2003 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.5-1m)

* Fri Nov  7 2003 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.4-1m)

* Wed Nov  5 2003 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.3-1m)

* Sat Sep 20 2003 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.2-1m)

* Wed Sep 10 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (2.0.1-3m)
- add BuildRequires: MySQL

* Thu Sep  4 2003 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.1-2m)
- rebuild against MySQL-4.0.14

* Tue Aug 12 2003 Kikutani Makoto <poo@momonga-linux.org>
- (2.0.1-1m)
- new upstream version
- remove create_postgresql.patch

* Mon Jul 21 2003 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.0-2m)
- rebuild against glibc-2.3.2

* Thu Apr 17 2003 Shigeyuki Yamashita <shige@cty-net.ne.jp>
- (2.0.0-1m)
- security update
  TCP Stream Reassembly Integer Overflow Vulnerability
  (reference: http://www.coresecurity.com/common/showdoc.php?idx=313&idxseccion=10)

* Sat Mar 15 2003 Kikutani Makoto <poo@momonga-linux.org>
- (1.9.1-3m)
- create_postgresql.patch for postgresql-7.3.x

* Sun Mar  8 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (1.9.1-2m)
  rebuild against openssl 0.9.7a

* Tue Mar  4 2003 Kazuhiko <kazuhiko@fdiary.net>
- (1.9.1-1m)
- fixes vulnerability in rpc decoder

* Thu Jan 23 2003 Shingo Akagaki <dora@kitty.dnsalias.org>
- (1.9.0-2m)
- rebuild against for postgresql

* Sat Oct  5 2002 Kazuhiko <kazuhiko@fdiary.net>
- (1.9.0-1m)

* Tue Aug 13 2002 Kikutani <poo@momonga-linux.org>
- (1.8.7-3m)
- added man page

* Mon Jul 22 2002 Kikutani <poo@momonga-linux.org>
- (1.8.7-2m)
- added --with-postgresql --with-mysql for %configure
- added contrib/create* *.pdf for %doc

* Mon Jul 22 2002 Kazuhiko <kazuhiko@fdiary.net>
- (1.8.7-1m)

* Sat Jul  6 2002 Kazuhiko <kazuhiko@fdiary.net>
- (1.8.6-1m)
